/*
 * key.h
 *
 *  Created on: Jul 31, 2021
 *      Author: aikebei
 */

#ifndef SRC_KEY_H_
#define SRC_KEY_H_

typedef unsigned short int uint16_t;
typedef unsigned char uint8_t;//将uint8_t别名为无符号字符
typedef unsigned long int uint32_t;
typedef struct
{
    uint8_t KeyLogic;
    uint8_t KeyPhysic;
    uint16_t KeyONCounts;
    uint8_t KeyOFFCounts;
    uint8_t KeyIsDeal;
}KEY_TypeDef;
extern KEY_TypeDef Key[];
#define     KEY_OFF         0
#define     KEY_ON          1
#define     KEY_HOLD        2
#define     KEY_IDLE        3
#define     KEY_ERROR       10

#define     HOLD_COUNTS         500 //长按记数
#define     SHAKES_COUNTS       5 //消抖实际

#define KEY_1_Pin GPIO_PIN_13
#define KEY_1_GPIO_Port GPIOC
#define KEY_2_Pin GPIO_PIN_14
#define KEY_2_GPIO_Port GPIOC
#define KEY_R_Pin GPIO_PIN_15
#define KEY_R_GPIO_Port GPIOC
#define KEY_O_Pin GPIO_PIN_0
#define KEY_O_GPIO_Port GPIOF
#define KEY_L_Pin GPIO_PIN_1
#define KEY_L_GPIO_Port GPIOF

void Key_Scan(void);
void Key_Deal(void);

#endif /* SRC_KEY_H_ */
